package java.lang;

public final class Boolean {
   public static final Boolean TRUE = new Boolean(true);
   public static final Boolean FALSE = new Boolean(false);
   private boolean value;

   public Boolean(boolean value) {
      this.value = value;
   }

   public Boolean(String s) {
      this(toBoolean(s));
   }

   public boolean booleanValue() {
      return this.value;
   }

   public static Boolean valueOf(String s) {
      return new Boolean(toBoolean(s));
   }

   public String toString() {
      return this.value ? "true" : "false";
   }

   public int hashCode() {
      return this.value ? 1231 : 1237;
   }

   public boolean equals(Object obj) {
      if (obj != null && obj instanceof Boolean) {
         return this.value == (Boolean)obj;
      } else {
         return false;
      }
   }

   public static boolean getBoolean(String name) {
      SecurityManager.setScopePermission();
      return toBoolean(System.getProperty(name));
   }

   private static boolean toBoolean(String name) {
      return name != null && name.toLowerCase().equals("true");
   }
}
