package java.lang;

public abstract class ClassLoader {
   private boolean initialized = false;

   protected ClassLoader() {
      SecurityManager.checksCreateClassLoader(1);
      this.init();
      this.initialized = true;
   }

   protected abstract Class loadClass(String var1, boolean var2) throws ClassNotFoundException;

   protected final Class defineClass(byte[] data, int offset, int length) {
      return this.defineClass((String)null, data, offset, length);
   }

   protected final native Class defineClass(String var1, byte[] var2, int var3, int var4);

   protected final native void resolveClass(Class var1);

   protected final native Class findSystemClass(String var1) throws ClassNotFoundException;

   private native void init();

   private native void checkInitialized();
}
