package java.lang;

public final class Double extends Number {
   public static final double POSITIVE_INFINITY = (double)Float.POSITIVE_INFINITY;
   public static final double NEGATIVE_INFINITY = (double)Float.NEGATIVE_INFINITY;
   public static final double NaN = NaN;
   public static final double MAX_VALUE = 1.7976931348623157E308;
   public static final double MIN_VALUE = MIN_NORMAL;
   private double value;

   public static native String toString(double var0);

   public static native Double valueOf(String var0) throws NumberFormatException;

   public static boolean isNaN(double v) {
      return v != v;
   }

   public static boolean isInfinite(double v) {
      return v == POSITIVE_INFINITY || v == NEGATIVE_INFINITY;
   }

   public Double(double value) {
      this.value = value;
   }

   public Double(String s) throws NumberFormatException {
      this(valueOf(s));
   }

   public boolean isNaN() {
      return isNaN(this.value);
   }

   public boolean isInfinite() {
      return isInfinite(this.value);
   }

   public String toString() {
      return String.valueOf(this.value);
   }

   public int intValue() {
      return (int)this.value;
   }

   public long longValue() {
      return (long)this.value;
   }

   public float floatValue() {
      return (float)this.value;
   }

   public double doubleValue() {
      return this.value;
   }

   public int hashCode() {
      long bits = doubleToLongBits(this.value);
      return (int)(bits ^ bits >> 32);
   }

   public boolean equals(Object obj) {
      return obj != null && obj instanceof Double && doubleToLongBits(((Double)obj).value) == doubleToLongBits(this.value);
   }

   public static native long doubleToLongBits(double var0);

   public static native double longBitsToDouble(long var0);
}
